/**
  ******************************************************************************
  * @file    vkl076.c
  * @author  kevin_guo
  * @version V1.2
  * @date    05-17-2020
  * @brief   This file contains all the vkl076 functions. 
	*          ļ VKl076
  ******************************************************************************
  * @attention
  ******************************************************************************
  */	
/* Includes ------------------------------------------------------------------*/
#include "vkl076.h"
  
/* extern variables ----------------------------------------------------------*/
/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
#define VKl076_CLK 10 //SCLźƵ,delay_nusʵ 50->10kHz 10->50kHz 5->100kHz
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
//segtab[]ӦʵʵоƬLCDߣ߼-VKl076ο·
unsigned char vkl076_segtab[Vkl076_SEGNUM]={
	9,															//SEG9
	10,11,12,13,14,15,16,17,18,19,	//SEG10-SEG19
	20,21,22,23,24,25,26,27,				//SEG20-SEG27
};
//LCDʵֻSEG10SEG21ʹ
//.hļVKl076_SEGNUM=12
//const unsigned char vkl076_segtab[VKl076_SEGNUM]={	
//	10,11,12,13,14,15,16,17,18,19,	//SEG10-SEG19
//	20,21,													//SEG20-SEG21
//};
//vkl076_dispramӦоƬʾRAM
unsigned char vkl076_dispram[Vkl076_SEGNUM/2];//ÿֽݶӦ2SEG
//Ӧvkl076_segtab[VKl076_SEGNUM]
//ʾRAM bufferΪ8λӦ2SEGbit7/bit3->com3,bit6/bit2->com2,bit5/bit1->com1,bit4/bit0->com0
//LCD ʵ  38
//1ǰλ2ʮλ3Ǹλ
/*ʾbufferlcdͼӳϵ
vkl076_dispram[VKl076_SEGNUM/2]=
{//com3   com2   com1     com0 //ӦоƬSEG  ӦʾRAM
	1D,     1E,    1F,      1A,     //seg9   			vkl076_dispram[0]-bit3-bit0
	  ,     1C,    1G,      1B,     //seg10				vkl076_dispram[0]-bit7-bit4
	2D,     2E,    2F,      2A,     //seg11				vkl076_dispram[1]-bit3-bit0
	  ,     2C,    2G,      2B,     //seg12				vkl076_dispram[1]-bit7-bit4
	3D,     3E,    3F,      3A,		  //seg13				vkl076_dispram[2]-bit3-bit0
	  ,     3C,    3G,      3B,			//seg14				vkl076_dispram[2]-bit7-bit4
}
*/
/*8ֵ 
     A
   F   B
     G
	 E   C
	   D
*/
unsigned char shuzi_zimo[15]= //ַֺģ
{
//0    1    2    3    4    5    6    7    8    9    -    L    o    H    i 
	0x5F,0x50,0x3D,0x79,0x72,0x6B,0x6F,0x51,0x7F,0x7B,0x20,0x0E,0x6C,0x76,0x50
};
unsigned char vkl076_segi,vkl076_comi;
unsigned char vkl076_maxcom;//com4com
/* Private function prototypes -----------------------------------------------*/
unsigned char Vkl076_InitSequence(void);
/* Private function ----------------------------------------------------------*/
/*******************************************************************************
* Function Name  : delay_nus
* Description    : ʱ1uS
* Input          : n->ʱʱnuS
* Output         : None
* Return         : None
*******************************************************************************/
void delay_nus(unsigned int n)	   
{
	unsigned char i;
	while(n--)
	{
		i=10;
		while(i--)
		{//nopָݵƬӦ޸
			__nop();
		}
	}
}
/*******************************************************************************
* Function Name  : delay_nms
* Description    : ʱ1mS
* Input          : n->ʱʱnmS
* Output         : None
* Return         : None
*******************************************************************************/
void delay_nms(unsigned long int n)
{
	while(n--)
	{
		delay_nus(1000);
	}
}
/*******************************************************************************
* Function Name  : I2CStart
* Description    : ʱ߸ʱɸߵ͵䣬ʾI2Cʼź
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void Vkl076_I2CStart( void )
{
  Vkl076_SCL_H();
  Vkl076_SDA_H();
  delay_nus(VKl076_CLK);
  Vkl076_SDA_L();
  delay_nus(VKl076_CLK);
}
/*******************************************************************************
* Function Name  : I2CStop
* Description    : ʱ߸ʱɵ͵ߵ䣬ʾI2Cֹͣź
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void Vkl076_I2CStop( void )
{
  Vkl076_SCL_H();
  Vkl076_SDA_L();
  delay_nus(VKl076_CLK);
  Vkl076_SDA_H();
  delay_nus(VKl076_CLK);
}
/*******************************************************************************
* Function Name  : I2CSlaveAck
* Description    : I2Cӻ豸Ӧѯ
* Input          : None
* Output         : None
* Return         : 0-ok 1-fail
*******************************************************************************/
unsigned char Vkl076_I2CSlaveAck( void )
{
  unsigned int TimeOut;
  unsigned char RetValue;
	
  Vkl076_SCL_L();
	//ƬSDAΪIOҪΪ
	 Vkl076_SET_SDA_IN();;
  delay_nus(VKl076_CLK);
  Vkl076_SCL_H();//9sclk

  TimeOut = 10000;
  while( TimeOut-- > 0 )
  {
    if( Vkl076_GET_SDA()!=0 )//ȡack
    {
      RetValue = 1;
    }
    else
    {
      RetValue = 0;
      break;
    }
  } 
	Vkl076_SCL_L();
	//ƬSDAΪIOҪΪ
	Vkl076_SET_SDA_OUT();  
  
  return RetValue;
}
/*******************************************************************************
* Function Name  : I2CCmdByte
* Description    : I2Cдһֽ,͸λ
* Input          : byte-Ҫд
* Output         : None
* Return         : None
*******************************************************************************/
void Vkl076_I2CCmdByte( unsigned char byte )
{
	unsigned char i=8;
	while (i--)
	{ 
		Vkl076_SCL_L();
		if(byte&0x80)
			Vkl076_SDA_H();
		else
			Vkl076_SDA_L();
		byte<<=1; 
		delay_nus(VKl076_CLK);
		Vkl076_SCL_H();     
		delay_nus(VKl076_CLK);
	}
}
/*******************************************************************************
* Function Name  : I2CDatByte
* Description    : I2Cдһֽ,͵λ
* Input          : byte-Ҫд
* Output         : None
* Return         : None
*******************************************************************************/
void Vkl076_I2CDatByte( unsigned char byte )
{
	unsigned char i=8;
	while (i--)
	{ 
		Vkl076_SCL_L();
		if(byte&0x01)
			Vkl076_SDA_H();
		else
			Vkl076_SDA_L();
		byte>>=1; 
		delay_nus(VKl076_CLK);
		Vkl076_SCL_H();     
		delay_nus(VKl076_CLK);
	}
}
/*******************************************************************************
* Function Name  : Write1Data
* Description    : д1ֽݵʾRAM
* Input          : Addr-дramĵַ
*                : Dat->дram
* Output         : None
* Return         : 0-ok 1-fail
*******************************************************************************/
unsigned char Write1DataVkl076(unsigned char Addr,unsigned char Dat)
{
	//START ź
	Vkl076_I2CStart(); 
	//SLAVEַ
	Vkl076_I2CCmdByte(Vkl076_ADDR); 
	if( 1 == Vkl076_I2CSlaveAck() )
	{		
		Vkl076_I2CStop();
		return 1; 
	}
	//ʾRAMַ
	if(Addr>0x1f)
		Vkl076_I2CCmdByte(Vkl076_ADDR5_1); 
	else
		Vkl076_I2CCmdByte(Vkl076_ADDR5_0); 
	if( 1 == Vkl076_I2CSlaveAck() )
	{
		Vkl076_I2CStop();
		return 1;
	}
	Vkl076_I2CCmdByte(Addr&0x1f); 
	if( 1 == Vkl076_I2CSlaveAck() )
	{
		Vkl076_I2CStop();
		return 1;
	}
	//ʾݣ1ֽݰ2SEG
	Vkl076_I2CDatByte(Dat);
	if( Vkl076_I2CSlaveAck()==1 )
	{
		Vkl076_I2CStop();
		return 1;
	}
	//STOPź
 Vkl076_I2CStop();
 return 0;   
}
/*******************************************************************************
* Function Name  : WritenData
* Description    : дݵʾRAM
* Input          : Addr-дramʼַ
*                : Databuf->дrambufferָ
*                : Cnt->дramݸ
* Output         : None
* Return         : 0-ok 1-fail
*******************************************************************************/
unsigned char  WritenDataVkl076(unsigned char Addr,unsigned char *Databuf,unsigned char Cnt)
{
	unsigned char n;
	
	//STARTź	
	Vkl076_I2CStart(); 									
	//SLAVEַ
	Vkl076_I2CCmdByte(Vkl076_ADDR); 	
	if( 1 == Vkl076_I2CSlaveAck() )
	{
		Vkl076_I2CStop();													
		return 0;										
	}
	//ʾRAMʼַ
	if(Addr>0x1f)
		Vkl076_I2CCmdByte(Vkl076_ADDR5_1); 
	else
		Vkl076_I2CCmdByte(Vkl076_ADDR5_0); 
	if( 1 == Vkl076_I2CSlaveAck() )
	{
		Vkl076_I2CStop();													
		return 0; 
	}
	Vkl076_I2CCmdByte(Addr&0x1f); 						
	if( 1 == Vkl076_I2CSlaveAck() )
	{
		Vkl076_I2CStop();													
		return 0;
	}
	//CntݵʾRAM
	for(n=0;n<Cnt;n++)
	{ 
		Vkl076_I2CDatByte(*Databuf++);
		if( Vkl076_I2CSlaveAck()==1 )
		{
			Vkl076_I2CStop();													
			return 0;
		}
	}
	//STOPź
	 Vkl076_I2CStop();											
	 return 0;    
}
/*******************************************************************************
* Function Name  : Vkl076_DisAll
* Description    : SEGʾͬһݣbit7/bit3-COM3 bit6/bit2-COM2 bit5/bit1-COM1 bit4/bit0-COM0
* 					     : 磺0xffȫ 0x00ȫ 0x55 0xaa 0x33 
* Input          dat->дram(1ֽݶӦ2SEG)  
* Output         : None
* Return         : None
*******************************************************************************/
void Vkl076_DisAll(unsigned char dat)
{
	unsigned char segi;
	unsigned char dispram[10];
	
	for(segi=0;segi<10;segi++)//SEGΪҪ1ֽڻ
	{
		dispram[segi]=dat;
	}
	dispram[9]&=0x0f; //İֽڻ0
	WritenDataVkl076(9,dispram,10);//8bitݶӦ2SEGÿ4bitݵַ1ÿ8λ1ACK
}
/*******************************************************************************
* Function Name  : DisSegComOn
* Description    : 1(1seg1comӦʾ)
* Input          seg->Ӧseg  
* 		           com->Ӧcom  
* Output         : None
* Return         : None
*******************************************************************************/
void Vkl076_DisSegComOn(unsigned char seg,unsigned char com)
{
		Write1DataVkl076(seg,(1<<(com)));//8λݵ4bitЧÿ4bitݵַ1ÿ8λ1ACK
}
/*******************************************************************************
* Function Name  : DisSegComOff
* Description    : ر1(1seg1comӦʾ)
* Input          seg->Ӧseg  
* 		           com->Ӧcom  
* Output         : None
* Return         : None
*******************************************************************************/
void Vkl076_DisSegComOff(unsigned char seg,unsigned char com)
{
		Write1DataVkl076(seg,~(1<<com));//8λݵ4bitЧÿ4bitݵַ1ÿ8λ1ACK
}
/*******************************************************************************
* Function Name  : Enter_Standby
* Description    : ͹ģʽ,ʾ
* Input          None 
* Output         : None
* Return         : 0-ok 1-fail
*******************************************************************************/
unsigned char Vkl076_Enter_Standby(void)
{		
	Vkl076_I2CStart();
	Vkl076_I2CCmdByte(Vkl076_ADDR); 
	if( 1 == Vkl076_I2CSlaveAck() )
	{
		Vkl076_I2CStop();
		return 1; 
	}
	Vkl076_I2CCmdByte(Vkl076_MODESET_1_3_OFF);		//ʾ 1/3bias
//		Vkl076_I2CCmdByte(Vkl076_MODESET_1_2_OFF);	//ʾ 1/2bias
	if( 1 == Vkl076_I2CSlaveAck() )
	{
		Vkl076_I2CStop();
		return 1; 
	}
	Vkl076_I2CStop();
  return 0; 
}
/*******************************************************************************
* Function Name  : Exit_Standby
* Description    : ˳͹ģʽ
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
unsigned char Vkl076_Exit_Standby(void)
{	
	unsigned char errorflag; //־λ1Ϊ0Ϊȷ
	
	//˳͹״̬vkl076	
	errorflag=Vkl076_InitSequence();
	
  return(errorflag);
}

/*******************************************************************************
* Function Name  : InitSequence
* Description    : ʼʱ
* Input          None 
* Output         : None
* Return         : 0-ok 1-fail
*******************************************************************************/
unsigned char Vkl076_InitSequence(void)
{		
	unsigned char n;
	
	vkl076_maxcom=4;
  //ϵʼʱ	
	//ϵ100uSڳʼ
  delay_nus(100);
	//STOPź
	Vkl076_I2CStop();
	//STARTź
	Vkl076_I2CStart();
	//SLAVEַ
	Vkl076_I2CCmdByte(Vkl076_ADDR); 
	if( 1 == Vkl076_I2CSlaveAck() )
	{
		Vkl076_I2CStop();	
		return 1;
	}
	//λ
	Vkl076_I2CCmdByte(Vkl076_SOFTRST);
	if( 1 == Vkl076_I2CSlaveAck() )
	{
		Vkl076_I2CStop();	
		return 1;
	}
	//ͬĹģʽһcomҲһ
//	Vkl076_I2CCmdByte(Vkl076_DISCTL|Vkl076_FRNOR|Vkl076_SRNOR|Vkl076_LINER );  //ϵĬ VDD=5V:<29uA  VDD=3.3V:<21uA 
	Vkl076_I2CCmdByte(Vkl076_DISCTL|Vkl076_FRPM3|Vkl076_SRPM1|Vkl076_FRAMER);  //ʡ VDD=5V:<12.7uA  VDD=3.3V:<8.5uA 
//	Vkl076_I2CCmdByte(Vkl076_DISCTL|Vkl076_FRPM1|Vkl076_SRPM1|Vkl076_FRAMER);  // VDD=5V:<13uA  VDD=3.3V:<9uA 
	if( 1 == Vkl076_I2CSlaveAck() )
	{
		Vkl076_I2CStop();	
		return 1;
	}
	//ӳʼַ bit5=0
	Vkl076_I2CCmdByte(Vkl076_ADDR5_0); //SEG32-SEG63ַ	
	if( 1 == Vkl076_I2CSlaveAck() )
	{
		Vkl076_I2CStop();	
		return 1;
	} 
	//ӳʼַ bit4~bit0=0
	Vkl076_I2CCmdByte(Vkl076_ADSET);//SEG0-SEG31ַ
	if( 1 == Vkl076_I2CSlaveAck() )
	{
		Vkl076_I2CStop();	
		return 1;
	}
	//ʾݣÿֽڰ2seg
	for(n=0;n<(Vkl076_SEGNUM/2+1);n++)  //SEGΪҪ1ֽڻ
	{ 
		Vkl076_I2CDatByte(0x00);    // ʼʾڴ,޸. 
		if( Vkl076_I2CSlaveAck()==1 )
		{
			Vkl076_I2CStop();	
			return 1;
		}
	}
	//STOPź
	Vkl076_I2CStop(); 
  //STARTź  
	Vkl076_I2CStart();
	//SLAVEַ
	Vkl076_I2CCmdByte(Vkl076_ADDR);
	if( 1 == Vkl076_I2CSlaveAck() )
	{
		Vkl076_I2CStop();	
		return 1;
	}
  //ʾģʽʾ
	Vkl076_I2CCmdByte(Vkl076_MODESET_1_3_ON);		//ʾ 1/3bias
//		Vkl076_I2CCmdByte(Vkl076_MODESET_1_2_ON);	//ʾ 1/2bias
	if( 1 == Vkl076_I2CSlaveAck() )
	{
		Vkl076_I2CStop();	
		return 1;
	}
	Vkl076_I2CStop();	
		
  return  0; 
}
/*******************************************************************************
* Function Name  : Lowlevel_Init
* Description    : ͨGPIO
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vkl076_Lowlevel_Init(void)
{
	//ͨߵƽͬӵƽת·
	//˺ݿͻƬӦ޸	
	Vkl076_SET_SDA_DIR();
	GPIO_SetMode(Vkl076_SCL_PORT, Vkl076_SCL_PIN, GPIO_MODE_OUTPUT);
	GPIO_SetMode(Vkl076_SDA_PORT, Vkl076_SDA_PIN, GPIO_MODE_QUASI);
		    
	Vkl076_SCL_H();  
	Vkl076_SDA_H(); 	
}
/*******************************************************************************
* Function Name  : Init
* Description    : ʼ
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vkl076_Init(void)
{	
	//ܽøݿͻƬӦ޸
	Vkl076_Lowlevel_Init();
	//ʼʱ
	Vkl076_InitSequence();
}
/*******************************************************************************
* Function Name  : disp_3num
* Description    : ʾ3λ
* Input          dat->3λ ʮ 
* Output         : None
* Return         : None
*******************************************************************************/
void disp_3num(unsigned int dat)
{		
	unsigned dat8;
	
	dat8=dat/100%10;	//ʾλ
	vkl076_dispram[0]&=0x7f;
	vkl076_dispram[0]|=shuzi_zimo[dat8];
	
	dat8=dat/10%10; 	//ʾʮλ
	vkl076_dispram[1]&=0x7f;
	vkl076_dispram[1]|=shuzi_zimo[dat8];
	
	dat8=dat%10;			//ʾλ
	vkl076_dispram[2]&=0x7f;
	vkl076_dispram[2]|=shuzi_zimo[dat8];
		
	if(dat<100)				//С100λʾ
	{
		vkl076_dispram[0]&=0x7f;
	}
	if(dat<10) 	//С10ʮλʾ
	{
		vkl076_dispram[1]&=0x7f;
	}
	//SEG11
//	Write1DataVkl076(9,vkl076_dispram[0]);
//	Write1DataVkl076(10,vkl076_dispram[1]);
//	Write1DataVkl076(11,vkl076_dispram[2]);
	//SEGͶ
	WritenDataVkl076(9,&vkl076_dispram[0],3);
}	
/*******************************************************************************
* Function Name  : test_Main
* Description    : 
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vkl076_Main(void)
{	
	Vkl076_Init();
	Vkl076_DisAll(0x00);
	while(1)
	{
		Vkl076_DisAll(0xff);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		
		Vkl076_DisAll(0x00);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		
		disp_3num(123);           //ʾ123
		delay_nms(3000);					//ʱ3S
		
		Vkl076_DisAll(0x00);			//LCDȫ
		for(vkl076_segi=0;vkl076_segi<Vkl076_SEGNUM;vkl076_segi++)//seg
		{
			for(vkl076_comi=0;vkl076_comi<vkl076_maxcom;vkl076_comi++)//com
			{
				Vkl076_DisSegComOn(vkl076_segtab[vkl076_segi],vkl076_comi);	//LCD
				delay_nms(300);				//ʱ300mS
				Vkl076_DisAll(0x00);	//LCDȫ
			}
		}
		
		Vkl076_DisAll(0xff);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		for(vkl076_segi=0;vkl076_segi<Vkl076_SEGNUM;vkl076_segi++)//seg
		{
			for(vkl076_comi=0;vkl076_comi<vkl076_maxcom;vkl076_comi++)//com
			{
				Vkl076_DisSegComOff(vkl076_segtab[vkl076_segi],vkl076_comi);	//LCDر
				delay_nms(300);				//ʱ300mS
				Vkl076_DisAll(0xff);	//LCDȫ
			}
		}
		delay_nms(1000);					//ʱ1S
		
		Vkl076_DisAll(0x00);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		
		Vkl076_Enter_Standby();		//͹ģʽ
		delay_nms(5000);					//ʱ5S
		
		Vkl076_Exit_Standby();		//˳͹ģʽ
	}
}
/************************END OF FILE****/
